package pl.ivend.pg2oracle;

import org.apache.log4j.Logger;
import org.apache.log4j.xml.DOMConfigurator;

public final class AppLogger {

	private static final String FILENAME_LOG4J = "log4j.xml";

	private static AppLogger instance;

	private Logger logger = Logger.getRootLogger();

	private AppLogger() {
		DOMConfigurator.configure(FILENAME_LOG4J);
	}

	public static AppLogger get() {
		if (instance == null) {
			instance = new AppLogger();
		}
		return instance;
	}

	public void error(Exception exception) {
		logger.error(null, exception);
	}

	public void error(Throwable throwable) {
		logger.error(null, throwable);
	}

	public void error(String message, Exception exception) {
		logger.error(message, exception);
	}

	public void error(String message, Throwable throwable) {
		logger.error(message, throwable);
	}

	public void info(String msg) {
		logger.info(msg);
	}

}
