package pl.ivend.pg2oracle.work;

import java.sql.Connection;
import java.util.List;

public interface IDatabase {

	Connection getInstance();

	List<String> getSchemas(String... schemas);

	boolean isSchema(String schemaName);

	void createSchema(String schemaName);

	SequenceDescription getSequence(String schemaName, String sequenceName);

	List<String> getSequences(String schemaName);

	boolean isSequence(String schemaName, String sequenceName);

	void createSequence(SequenceDescription sequence);

	void updateSequence(SequenceDescription sequence);

	List<TableDescription> getTables(String schemaName, String... tables);

	boolean isTable(String schemaName, String tableName);

	void createTable(TableDescription table);

	List<ViewDescription> getViews(String schemaName);

	boolean isView(String schemaName, String viewName);

	void createView(ViewDescription view);

	void getDataAsync(TableDescription table, IDataAsync dataAsync);

	void insertData(TableDescription table, List<ColumnData> dataList);

	List<ConstraintDescription> getPrimaryKeys(String schemaName, String tableName);

	List<ConstraintDescription> getConstraints(String schemaName, String tableName);

	boolean isConstraint(String schemaName, String tableName, String constraintName);

	void createConstraint(ConstraintDescription constraint);

	void addConstraintReferencesGrants(ConstraintDescription constraint);

	List<TriggerDescription> getTriggers(String schemaName);

	boolean isTrigger(String schemaName, String name);

	void createTrigger(TriggerDescription trigger);

}
